# -*- coding: utf-8 -*-

from rest_framework import generics

from thux.api.views import QuerysetMixin
from thux.api.permissions import ThuxModelPermissions

from .. import models
from . import serializers


class CarriageList(QuerysetMixin, generics.ListAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Carriage.objects.all()
    serializer_class = serializers.CarriageSerializer


class CarriageRetrieve(generics.RetrieveAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Carriage.objects.all()
    serializer_class = serializers.CarriageSerializer


class CarriageCreate(generics.CreateAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Carriage.objects.all()
    serializer_class = serializers.CarriageSerializerCreate


class CarriageUpdate(generics.UpdateAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Carriage.objects.all()
    serializer_class = serializers.CarriageSerializerUpdate


class DeliveryList(QuerysetMixin, generics.ListAPIView):
    permission_classes = (ThuxModelPermissions, )
    queryset = models.Delivery.objects.all()
    serializer_class = serializers.DeliverySerializer


class DeliveryRetrieve(generics.RetrieveAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Delivery.objects.all()
    serializer_class = serializers.DeliverySerializer


class DeliveryCreate(generics.CreateAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Delivery.objects.all()
    serializer_class = serializers.DeliverySerializerCreate


class DeliveryUpdate(generics.UpdateAPIView):
    permission_classes = (ThuxModelPermissions,)
    queryset = models.Delivery.objects.all()
    serializer_class = serializers.DeliverySerializerUpdate
